;; $Id: update.cl,v 1.2.2.6.6.1 2002/04/04 23:26:18 layer Exp $

(progn
  (defvar error-detected nil)
  (defvar do-bundle-update t)

  (format t "~%~%
When \"Done\" prints after building new images, exit the Lisp.~%~%")
  
  (defun print-bli-form (file build debug s &aux (*print-case* :downcase))
    (print
     `(handler-case
	  (progn (setq *print-startup-message*
		   (let ((r (reverse *print-startup-message*)))
		     (reverse
		      (pushnew '(:external-format . t) r
			       :test #'equal))))
		 (build-lisp-image
		  ,file
		  ,@(when (and (match-regexp "allegro*" file :return nil)
			       (probe-file "src/cg/loadsfi.cl"))
		      (list :lisp-files '(list "src/cg/loadsfi.cl")
			    :discard-source-file-info nil))
		  :verbose t
		  :build-input ,debug
		  :build-output ,build
		  #+mswindows :splash-from-file
		  #+mswindows (translate-logical-pathname "sys:allegro.dib")))
	(error () (exit 1)))
     s)
    (print '(exit 0) s)
    (terpri s))

  (dolist (dxl-file (directory "*.dxl"))
    (let ((file (file-namestring dxl-file))
	  (dxl-file (namestring dxl-file)))
      (if* (not (member file '("alisp.dxl" "alisp8.dxl" "mlisp.dxl"
			       "mlisp8.dxl"
			       "allegro.dxl" "allegro-ansi.dxl"
			       "clim.dxl")
			:test #'string-equal))
	 thenret ;; ignore these files
	 else (format t "Making new ~a...~%" file)
	      (let ((orig-dxl (format nil "~aorig.dxl" (pathname-name file)))
		    (old-dxl (format nil "~aold.dxl" (pathname-name file)))
		    (build (format nil "~a.build" (pathname-name file)))
		    (debug (format nil "~a.debug" (pathname-name file)))
		    (lisp-exe (pathname-name file))
		    prev)

		(ignore-errors
		 (when do-bundle-update 
		   (setq do-bundle-update nil)
		   (format t "~
Performing bundle check.
The bundle check may take several minutes.")
		   (with-open-file (s "bunup-build.cl" :direction :output
				    :if-exists :supersede)
		     (format s "~
 (build-lisp-image \"tmpbu.dxl\" :verbose t :build-output \"tmpbu.build\"
                   :include-devel-env t :build-input \"tmpbu.debug\"
                   :include-ide nil :restart-app-function nil
                   :restart-init-function nil)
 (exit 0)"))
		   (run-shell-command (format nil "~
~a +s bunup-build.cl -I ~a -qq -batch -backtrace-on-error"
					      lisp-exe file)
				      :show-window :minimized)
		   (with-open-file (s "bunup-check.cl" :direction :output
				    :if-exists :supersede)
		     (format s "~
 (progn
   (when (fboundp 'excl::update-bundle-check)
     (unless (excl::update-bundle-check t)
       (excl::update-bundle-files)))
   (exit 0))
"))
		   (run-shell-command (format nil "~
~a +s bunup-check.cl -I tmpbu.dxl -qq -batch -backtrace-on-error"
					      lisp-exe)
				      :show-window :minimized)
		   (delete-file "tmpbu.dxl")
		   (format t "~&Finished bundle check.~%")))
		

		(if* (not (probe-file orig-dxl))
		   then (setq prev (rename-file-raw dxl-file orig-dxl))
		   else (ignore-errors (delete-file old-dxl))
			(setq prev (rename-file-raw dxl-file old-dxl)))
		(with-open-file (s "update1.cl" :direction :output
				 :if-exists :supersede)
		  (print-bli-form file build debug s))
		(when (/= 0
			  (run-shell-command
			   (format nil
				   "~a +s update1.cl -I ~a -qq ~a"
				   lisp-exe orig-dxl
				   "-batch -backtrace-on-error")
			   :show-window :minimized))
		  (setq error-detected t)
		  (ignore-errors (delete-file dxl-file))
		  (rename-file-raw prev dxl-file))
		(delete-file "update1.cl")
		(when (or error-detected (not (probe-file file)))
		  (format t "Build of ~a failed (check ~a for errors).~%"
			  file build)
		  (return))))))

  (when (not error-detected) (format t "Done.~%"))
  (values))

